<template>
  <section class="lk-page two-col-page container">
    <div class="two-col-page__content">
      <nuxt-child/>
    </div>

    <div class="two-col-page__right lk-page__right">

      <nav class="lk-page__nav">
        <ul>
          <li class="lk-page__nav-item">
            <nuxt-link to="/personal/bookings" class="lk-page__nav-link">Бронирования</nuxt-link>
          </li>
          <li class="lk-page__nav-item">
            <nuxt-link to="/personal/profile" class="lk-page__nav-link">Профиль</nuxt-link>
          </li>
          <li class="lk-page__nav-item">
            <nuxt-link to="/personal/orders" class="lk-page__nav-link">Заказы</nuxt-link>
          </li>
          <li class="lk-page__nav-item lk-page__nav-item--count">
            <nuxt-link to="/personal/account" class="lk-page__nav-link">Счет</nuxt-link>
            <nuxt-link to="/personal/account"
                       v-if="balance"
                       class="lk-page__count">{{ balance | rubCurrency }}</nuxt-link>
          </li>
        </ul>
      </nav>

      <div class="current-book"
           v-if="activeBooking">
        <nuxt-link :to="`/places/${activeBooking.place.id}`"
                   class="current-book__img">
          <img :src="activeBooking.place.images[0].url" alt="Текущее бронирование">
        </nuxt-link>

        <div class="current-book__tag">
          Текущее бронирование
        </div>

        <nuxt-link :to="`/places/${activeBooking.place.id}`"
                   class="current-book__name">
          {{ activeBooking.place.name }}
        </nuxt-link>

        <span class="current-book__info" v-html="getDateInfo(activeBooking)"></span>
      </div>
    </div>
  </section>
</template>

<script>
  import { mapGetters } from 'vuex';
  import { months, weekDays } from '../assets/js/helpers/consts';

  import {
    getUserBookings
  } from '../service/deliroom-service';

  export default {
    name: 'ProfilePage',
    middleware: 'auth',
    components: {

    },
    data: () => ({
      activeBooking: null,
      months: months,
      weekDays: weekDays
    }),

    async mounted() {
      const timer = setInterval(async () => {
        if (!this.$store.state.auth.tokenRefreshing) {
          clearInterval(timer);

          const bookings = await getUserBookings();

          this.getActiveBooking(bookings.data);
        }
      }, 100);
    },

    watch: {
      $route() {
        window.scrollTo({top: 0, behavior: 'smooth'});
      }
    },

    computed: {
      ...mapGetters({
        balance: 'user/balance'
      })
    },

    methods: {
      getDateInfo(booking) {
        if (!booking) return;

        const startISODateStr = booking.start_local.toString();
        const endISODateStr = booking.end_local.toString();

        const startISODate = new Date(startISODateStr.substr(0, 10));

        const getTimeLabel = (date) => date.substr(11, 5);

        return `${this.weekDays[startISODate.getDay()].short} ${startISODate.getDate()} ${this.months[startISODate.getMonth()]},&nbsp;
                <b>${getTimeLabel(startISODateStr)}&ndash;${getTimeLabel(endISODateStr)}</b>`
      },

      isBookingActive(booking) {
        const startDate = new Date(booking.start);
        const endDate = new Date(booking.end);
        const currentDate = new Date();

        return startDate < currentDate && currentDate < endDate;
      },

      getActiveBooking(bookings) {
        this.activeBooking = bookings.filter((booking) => this.isBookingActive(booking))[0];
      },
    }

  }
</script>

